Package icyllis.arc3d.opengl

# Interface GLInterfaceCommon

All Known Subinterfaces:
  `GLInterface`

All Known Implementing Classes:
  `GLCaps_GL`, `GLCaps_GLES`

public interface GLInterfaceCommon
OpenGL 3.1 Core and OpenGL ES 3.0 have a common subset.

No javadoc here, please refer to LWJGL javadoc and OpenGL specification.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `glActiveTexture(int texture)`
  `void`
  `glAttachShader(int program, int shader)`
  `void`
  `glBindBuffer(int target, int buffer)`
  `void`
  `glBindBufferBase(int target, int index, int buffer)`
  `void`
  `glBindBufferRange(int target, int index, int buffer, long offset, long size)`
  `void`
  `glBindFramebuffer(int target, int framebuffer)`
  `void`
  `glBindRenderbuffer(int target, int renderbuffer)`
  `void`
  `glBindSampler(int unit, int sampler)`
  `void`
  `glBindTexture(int target, int texture)`
  `void`
  `glBindVertexArray(int array)`
  `void`
  `glBlendEquation(int mode)`
  `void`
  `glBlendFunc(int sfactor, int dfactor)`
  `void`
  `glBlitFramebuffer(int srcX0, int srcY0, int srcX1, int srcY1, int dstX0, int dstY0, int dstX1, int dstY1, int mask, int filter)`
  `void`
  `glBufferData(int target, long size, long data, int usage)`
  `void`
  `glBufferSubData(int target, long offset, long size, long data)`
  `int`
  `glCheckFramebufferStatus(int target)`
  `void`
  `glClearBufferfi(int buffer, int drawbuffer, float depth, int stencil)`
  `void`
  `glClearBufferfv(int buffer, int drawbuffer, FloatBuffer value)`
  `void`
  `glClearBufferiv(int buffer, int drawbuffer, IntBuffer value)`
  `int`
  `glClientWaitSync(long sync, int flags, long timeout)`
  `void`
  `glColorMask(boolean red, boolean green, boolean blue, boolean alpha)`
  `void`
  `glCompileShader(int shader)`
  `void`
  `glCopyBufferSubData(int readTarget, int writeTarget, long readOffset, long writeOffset, long size)`
  `void`
  `glCopyTexSubImage2D(int target, int level, int xoffset, int yoffset, int x, int y, int width, int height)`
  `int`
  `glCreateProgram()`
  `int`
  `glCreateShader(int type)`
  `void`
  `glDeleteBuffers(int buffer)`
  `void`
  `glDeleteFramebuffers(int framebuffer)`
  `void`
  `glDeleteProgram(int program)`
  `void`
  `glDeleteRenderbuffers(int renderbuffer)`
  `void`
  `glDeleteSamplers(int sampler)`
  `void`
  `glDeleteShader(int shader)`
  `void`
  `glDeleteSync(long sync)`
  `void`
  `glDeleteTextures(int texture)`
  `void`
  `glDeleteVertexArrays(int array)`
  `void`
  `glDepthFunc(int func)`
  `void`
  `glDepthMask(boolean flag)`
  `void`
  `glDetachShader(int program, int shader)`
  `void`
  `glDisable(int cap)`
  `void`
  `glDrawArrays(int mode, int first, int count)`
  `void`
  `glDrawArraysInstanced(int mode, int first, int count, int instancecount)`
  `void`
  `glDrawBuffers(int[] bufs)`
  `void`
  `glDrawElements(int mode, int count, int type, long indices)`
  `void`
  `glDrawElementsInstanced(int mode, int count, int type, long indices, int instancecount)`
  `void`
  `glEnable(int cap)`
  `void`
  `glEnableVertexAttribArray(int index)`
  `long`
  `glFenceSync(int condition, int flags)`
  `void`
  `glFinish()`
  `void`
  `glFlush()`
  `void`
  `glFramebufferRenderbuffer(int target, int attachment, int renderbuffertarget, int renderbuffer)`
  `void`
  `glFramebufferTexture2D(int target, int attachment, int textarget, int texture, int level)`
  `void`
  `glFrontFace(int mode)`
  `int`
  `glGenBuffers()`
  `int`
  `glGenFramebuffers()`
  `int`
  `glGenRenderbuffers()`
  `int`
  `glGenSamplers()`
  `int`
  `glGenTextures()`
  `int`
  `glGenVertexArrays()`
  `int`
  `glGetError()`
  `int`
  `glGetInteger(int pname)`
  `int`
  `glGetProgrami(int program, int pname)`
  `String`
  `glGetProgramInfoLog(int program)`
  `int`
  `glGetShaderi(int shader, int pname)`
  `String`
  `glGetShaderInfoLog(int shader)`
  `String`
  `glGetString(int name)`
  `int`
  `glGetUniformBlockIndex(int program, CharSequence uniformBlockName)`
  `int`
  `glGetUniformLocation(int program, CharSequence name)`
  `void`
  `glLineWidth(float width)`
  `void`
  `glLinkProgram(int program)`
  `long`
  `glMapBufferRange(int target, long offset, long length, int access)`
  `void`
  `glPixelStorei(int pname, int param)`
  `void`
  `glRenderbufferStorage(int target, int internalformat, int width, int height)`
  `void`
  `glRenderbufferStorageMultisample(int target, int samples, int internalformat, int width, int height)`
  `void`
  `glSamplerParameterf(int sampler, int pname, float param)`
  `void`
  `glSamplerParameteri(int sampler, int pname, int param)`
  `void`
  `glScissor(int x, int y, int width, int height)`
  `void`
  `glShaderSource(int shader, int count, long strings, long length)`
  `void`
  `glStencilFunc(int func, int ref, int mask)`
  `void`
  `glStencilFuncSeparate(int face, int func, int ref, int mask)`
  `void`
  `glStencilMask(int mask)`
  `void`
  `glStencilMaskSeparate(int face, int mask)`
  `void`
  `glStencilOp(int sfail, int dpfail, int dppass)`
  `void`
  `glStencilOpSeparate(int face, int sfail, int dpfail, int dppass)`
  `void`
  `glTexImage2D(int target, int level, int internalformat, int width, int height, int border, int format, int type, long pixels)`
  `void`
  `glTexParameteri(int target, int pname, int param)`
  `void`
  `glTexParameteriv(int target, int pname, IntBuffer params)`
  `void`
  `glTexSubImage2D(int target, int level, int xoffset, int yoffset, int width, int height, int format, int type, long pixels)`
  `void`
  `glUniform1i(int location, int v0)`
  `void`
  `glUniformBlockBinding(int program, int uniformBlockIndex, int uniformBlockBinding)`
  `boolean`
  `glUnmapBuffer(int target)`
  `void`
  `glUseProgram(int program)`
  `void`
  `glVertexAttribDivisor(int index, int divisor)`
  `void`
  `glVertexAttribIPointer(int index, int size, int type, int stride, long pointer)`
  `void`
  `glVertexAttribPointer(int index, int size, int type, boolean normalized, int stride, long pointer)`
  `void`
  `glViewport(int x, int y, int width, int height)`

- ## Method Details

  - ### glEnable

    void glEnable(int cap)

  - ### glDisable

    void glDisable(int cap)

  - ### glFrontFace

    void glFrontFace(int mode)

  - ### glLineWidth

    void glLineWidth(float width)

  - ### glGenTextures

    int glGenTextures()

  - ### glTexParameteri

    void glTexParameteri(int target, int pname, int param)

  - ### glTexParameteriv

    void glTexParameteriv(int target, int pname, IntBuffer params)

  - ### glTexImage2D

    void glTexImage2D(int target, int level, int internalformat, int width, int height, int border, int format, int type, long pixels)

  - ### glTexSubImage2D

    void glTexSubImage2D(int target, int level, int xoffset, int yoffset, int width, int height, int format, int type, long pixels)

  - ### glCopyTexSubImage2D

    void glCopyTexSubImage2D(int target, int level, int xoffset, int yoffset, int x, int y, int width, int height)

  - ### glDeleteTextures

    void glDeleteTextures(int texture)

  - ### glBindTexture

    void glBindTexture(int target, int texture)

  - ### glPixelStorei

    void glPixelStorei(int pname, int param)

  - ### glBlendFunc

    void glBlendFunc(int sfactor, int dfactor)

  - ### glColorMask

    void glColorMask(boolean red, boolean green, boolean blue, boolean alpha)

  - ### glDepthFunc

    void glDepthFunc(int func)

  - ### glDepthMask

    void glDepthMask(boolean flag)

  - ### glStencilOp

    void glStencilOp(int sfail, int dpfail, int dppass)

  - ### glStencilFunc

    void glStencilFunc(int func, int ref, int mask)

  - ### glStencilMask

    void glStencilMask(int mask)

  - ### glDrawArrays

    void glDrawArrays(int mode, int first, int count)

  - ### glDrawElements

    void glDrawElements(int mode, int count, int type, long indices)

  - ### glFlush

    void glFlush()

  - ### glFinish

    void glFinish()

  - ### glGetError

    int glGetError()

  - ### glGetString

    @Nullable String glGetString(int name)

  - ### glGetInteger

    int glGetInteger(int pname)

  - ### glScissor

    void glScissor(int x, int y, int width, int height)

  - ### glViewport

    void glViewport(int x, int y, int width, int height)

  - ### glActiveTexture

    void glActiveTexture(int texture)

  - ### glBlendEquation

    void glBlendEquation(int mode)

  - ### glGenBuffers

    int glGenBuffers()

  - ### glDeleteBuffers

    void glDeleteBuffers(int buffer)

  - ### glBindBuffer

    void glBindBuffer(int target, int buffer)

  - ### glBufferData

    void glBufferData(int target, long size, long data, int usage)

  - ### glBufferSubData

    void glBufferSubData(int target, long offset, long size, long data)

  - ### glUnmapBuffer

    boolean glUnmapBuffer(int target)

  - ### glDrawBuffers

    void glDrawBuffers(int[] bufs)

  - ### glStencilOpSeparate

    void glStencilOpSeparate(int face, int sfail, int dpfail, int dppass)

  - ### glStencilFuncSeparate

    void glStencilFuncSeparate(int face, int func, int ref, int mask)

  - ### glStencilMaskSeparate

    void glStencilMaskSeparate(int face, int mask)

  - ### glCreateProgram

    int glCreateProgram()

  - ### glDeleteProgram

    void glDeleteProgram(int program)

  - ### glCreateShader

    int glCreateShader(int type)

  - ### glDeleteShader

    void glDeleteShader(int shader)

  - ### glAttachShader

    void glAttachShader(int program, int shader)

  - ### glDetachShader

    void glDetachShader(int program, int shader)

  - ### glShaderSource

    void glShaderSource(int shader, int count, long strings, long length)

  - ### glCompileShader

    void glCompileShader(int shader)

  - ### glLinkProgram

    void glLinkProgram(int program)

  - ### glUseProgram

    void glUseProgram(int program)

  - ### glGetShaderi

    int glGetShaderi(int shader, int pname)

  - ### glGetProgrami

    int glGetProgrami(int program, int pname)

  - ### glGetShaderInfoLog

    String glGetShaderInfoLog(int shader)

  - ### glGetProgramInfoLog

    String glGetProgramInfoLog(int program)

  - ### glGetUniformLocation

    int glGetUniformLocation(int program, CharSequence name)

  - ### glUniform1i

    void glUniform1i(int location, int v0)

  - ### glEnableVertexAttribArray

    void glEnableVertexAttribArray(int index)

  - ### glVertexAttribPointer

    void glVertexAttribPointer(int index, int size, int type, boolean normalized, int stride, long pointer)

  - ### glVertexAttribIPointer

    void glVertexAttribIPointer(int index, int size, int type, int stride, long pointer)

  - ### glGenVertexArrays

    int glGenVertexArrays()

  - ### glDeleteVertexArrays

    void glDeleteVertexArrays(int array)

  - ### glBindVertexArray

    void glBindVertexArray(int array)

  - ### glGenFramebuffers

    int glGenFramebuffers()

  - ### glDeleteFramebuffers

    void glDeleteFramebuffers(int framebuffer)

  - ### glBindFramebuffer

    void glBindFramebuffer(int target, int framebuffer)

  - ### glCheckFramebufferStatus

    int glCheckFramebufferStatus(int target)

  - ### glFramebufferTexture2D

    void glFramebufferTexture2D(int target, int attachment, int textarget, int texture, int level)

  - ### glFramebufferRenderbuffer

    void glFramebufferRenderbuffer(int target, int attachment, int renderbuffertarget, int renderbuffer)

  - ### glBlitFramebuffer

    void glBlitFramebuffer(int srcX0, int srcY0, int srcX1, int srcY1, int dstX0, int dstY0, int dstX1, int dstY1, int mask, int filter)

  - ### glClearBufferiv

    void glClearBufferiv(int buffer, int drawbuffer, IntBuffer value)

  - ### glClearBufferfv

    void glClearBufferfv(int buffer, int drawbuffer, FloatBuffer value)

  - ### glClearBufferfi

    void glClearBufferfi(int buffer, int drawbuffer, float depth, int stencil)

  - ### glBindBufferBase

    void glBindBufferBase(int target, int index, int buffer)

  - ### glBindBufferRange

    void glBindBufferRange(int target, int index, int buffer, long offset, long size)

  - ### glGenRenderbuffers

    int glGenRenderbuffers()

  - ### glDeleteRenderbuffers

    void glDeleteRenderbuffers(int renderbuffer)

  - ### glBindRenderbuffer

    void glBindRenderbuffer(int target, int renderbuffer)

  - ### glRenderbufferStorage

    void glRenderbufferStorage(int target, int internalformat, int width, int height)

  - ### glRenderbufferStorageMultisample

    void glRenderbufferStorageMultisample(int target, int samples, int internalformat, int width, int height)

  - ### glMapBufferRange

    long glMapBufferRange(int target, long offset, long length, int access)

  - ### glDrawArraysInstanced

    void glDrawArraysInstanced(int mode, int first, int count, int instancecount)

  - ### glDrawElementsInstanced

    void glDrawElementsInstanced(int mode, int count, int type, long indices, int instancecount)

  - ### glCopyBufferSubData

    void glCopyBufferSubData(int readTarget, int writeTarget, long readOffset, long writeOffset, long size)

  - ### glGetUniformBlockIndex

    int glGetUniformBlockIndex(int program, CharSequence uniformBlockName)

  - ### glUniformBlockBinding

    void glUniformBlockBinding(int program, int uniformBlockIndex, int uniformBlockBinding)

  - ### glFenceSync

    long glFenceSync(int condition, int flags)

  - ### glDeleteSync

    void glDeleteSync(long sync)

  - ### glClientWaitSync

    int glClientWaitSync(long sync, int flags, long timeout)

  - ### glGenSamplers

    int glGenSamplers()

  - ### glDeleteSamplers

    void glDeleteSamplers(int sampler)

  - ### glBindSampler

    void glBindSampler(int unit, int sampler)

  - ### glSamplerParameteri

    void glSamplerParameteri(int sampler, int pname, int param)

  - ### glSamplerParameterf

    void glSamplerParameterf(int sampler, int pname, float param)

  - ### glVertexAttribDivisor

    void glVertexAttribDivisor(int index, int divisor)